import { WeakStorage } from "./types";
declare type WeakStorageCreator = () => WeakStorage;
export declare function weakMemoizeCreator(cacheCreator?: WeakStorageCreator): <Arg extends object, T extends any[], Return>(func: (x: Arg, ...rest: T) => Return, cache?: WeakStorage) => (x: Arg, ...rest: T) => Return;
export declare const kashe: <Arg extends object, T extends any[], Return>(func: (x: Arg, ...rest: T) => Return, cache?: WeakStorage) => (x: Arg, ...rest: T) => Return;
export declare function swap<T, K, R>(fn: (t: T, k: K) => R): (k: K, T: T) => R;
declare type BoxedCall<T extends any[], K> = (state: object, ...rest: T) => K;
/**
 * Prepends function with an additional argument, which would be used as a "box" key layer
 * @param fn
 */
export declare function boxed<T extends any[], K>(fn: (...args: T) => K): BoxedCall<T, K>;
/**
 * Prepends function with an additional argument, which would be used as "cache-dimension" key later
 * @param fn
 */
export declare function inboxed<T extends any[], K>(fn: (...args: T) => K): BoxedCall<T, K>;
/**
 * Forks internal cache, creating another cache dimension
 * @param fn - function to memoize
 * @param [options]
 * @param [options.singleton=false] force single variant for an internal cache
 */
export declare function fork<T extends any[], K>(fn: (...args: T) => K, options?: {
    singleton?: boolean;
}): (...args: T) => K;
export {};
